#[derive(Clone)]
struct Substring {
  idx: usize,
  s: Vec<u8>
}

pub fn entry(needle: &str, haystack: &str) -> Option<usize> {
  let bytes = needle.bytes().collect::<Vec<u8>>();
  let substrs = substrings(haystack.bytes().collect(), 0);
  substrs.iter().filter(|x| x.s == bytes).next().map(|x| x.idx)
}

fn substrings(mut s: Vec<u8>, idx: usize) -> Vec<Substring> {
  if s.len() == 0 {
    return vec![Substring { idx, s: vec![] }]
  }
  let first = s.remove(0);
  let substrs = substrings(s, idx+1);
  let mut result = vec![Substring { idx, s: vec![] }];
  for substr in substrs {
    result.push(substr.clone());
    if substr.idx == idx + 1 {
      let mut bytes = substr.s.clone();
      bytes.insert(0, first);
      result.push(Substring { idx, s: bytes  });
    }
  }
  result
}
